Procedure.s DiskFamily(Code.s)
Protected Model.s = ""
Restore HDD_CODES
Repeat
	Read.s HDDModel.s
	If HDDModel = ""
		Break
	EndIf
	Read.s HDDCodeExpression.s
	If CreateRegularExpression(0, HDDCodeExpression)
		If MatchRegularExpression(0, UCase(Code))
			FreeRegularExpression(0)
			Model = HDDModel
			Break
		EndIf
		FreeRegularExpression(0)
	EndIf
ForEver
ProcedureReturn Model
EndProcedure

DataSection
	HDD_CODES:
		Data.s "ExcelStor J240", "^EXCELSTOR TECHNOLOGY J240$"
		Data.s "ExcelStor J340", "^EXCELSTOR TECHNOLOGY J340$"
		Data.s "ExcelStor J360", "^EXCELSTOR TECHNOLOGY J360$"
		Data.s "ExcelStor J680", "^EXCELSTOR TECHNOLOGY J680$"
		Data.s "ExcelStor J880", "^EXCELSTOR TECHNOLOGY J880$"
		Data.s "IBM Deskstar 60GXP", "(IBM-|HITACHI )?IC35L0[12346]0AVER07"
		Data.s "IBM Deskstar 40GV & 75GXP", "(IBM-)?DTLA-30[57]0[123467][05]"
		Data.s "Fujitsu M1623TAU", "^FUJITSU M1623TAU$"
		Data.s "Fujitsu MHM2200AT", "^FUJITSU MHM2200AT"
		Data.s "Fujitsu MHM2150AT", "^FUJITSU MHM2150AT"
		Data.s "Fujitsu MHM2100AT", "^FUJITSU MHM2100AT"
		Data.s "Fujitsu MHM2060AT", "^FUJITSU MHM2060AT"
		Data.s "Fujitsu MHG", "^FUJITSU MHG2...ATU?"
		Data.s "Fujitsu MHH", "^FUJITSU MHH2...ATU?"
		Data.s "Fujitsu MHJ", "^FUJITSU MHJ2...ATU?"
		Data.s "Fujitsu MHK", "^FUJITSU MHK2...ATU?"
		Data.s "Fujitsu MHL2300AT", "^FUJITSU MHL2300AT$"
		Data.s "Fujitsu MHN", "^FUJITSU MHN2...AT$"
		Data.s "Fujitsu MHR2020AT", "^FUJITSU MHR2020AT$"
		Data.s "Fujitsu MHR2040AT", "^FUJITSU MHR2040AT$"
		Data.s "Fujitsu MHSxxxxAT", "^FUJITSU MHS20[6432]0AT(  .)?$"
		Data.s "Fujitsu MHT", "^FUJITSU MHT2...(AH|AS|AT|BH)U?"
		Data.s "Fujitsu MHU", "^FUJITSU MHU2...ATU?"
		Data.s "Fujitsu MHV", "^FUJITSU MHV2...(AH|AS|AT|BH|BS|BT)"
		Data.s "Fujitsu MPA..MPG", "^FUJITSU MP[A-G]3...A[HTEV]U?"
		Data.s "Fujitsu MHW2 BH", "^FUJITSU MHW2(04|06|08|10|12|16)0BH$"
		Data.s "Samsung SV4012H", "^SAMSUNG SV4012H$"
		Data.s "Samsung SV0412H", "^SAMSUNG SV0412H$"
		Data.s "Samsung SV1204H", "^SAMSUNG SV1204H$"
		Data.s "Samsung SV0322A", "^SAMSUNG SV0322A$"
		Data.s "Samsung SP40A2H with RR100-07 firmware",     "^SAMSUNG SP40A2H$"
		Data.s "Samsung SP8004H with QW100-61 firmware", "^SAMSUNG SP8004H$"
		Data.s "Samsung SpinPoint T133", "^SAMSUNG HD(250KD|(30[01]|320|40[01])L[DJ])$"
		Data.s "Samsung SpinPoint T166", "^SAMSUNG HD(080G|160H|32[01]K|403L|50[01]L)J$"
		Data.s "Samsung SpinPoint P120", "^SAMSUNG SP(16[01]3|2[05][01]4)[CN]$"
		Data.s "Samsung SpinPoint P80 SD", "^SAMSUNG HD(080H|120I|160J)J$"
		Data.s "Samsung SpinPoint P80", "^SAMSUNG SP(0451|08[0124]2|12[0145]3|16[0145]4)[CN]$"
		Data.s "Samsung SpinPoint F1", "^SAMSUNG HD(753L|642J|501I|322H|25[12]H|103U|16[12]G)J$"
		Data.s "Samsung SpinPoint F1 CE", "^SAMSUNG HA(751L|501I|321H|251H|101U)J$"
		Data.s "Samsung SpinPoint F1 DT", "^SAMSUNG HD(753LI|642JI|083GJ)$"
		Data.s "Samsung SpinPoint F1 RAID Class", "^SAMSUNG HE(753L|642J|502I|322H|252H|103U)J$"
		Data.s "Samsung SpinPoint F3", "^SAMSUNG HD(754J|502H|103S)J$"
		Data.s "Samsung SpinPoint M5", "^SAMSUNG HM(250JI|1(60|21)H[IC])$"
		Data.s "Samsung SpinPoint M6", "^SAMSUNG HM([54]00L|(320|251)J)I$"
		Data.s "Samsung SpinPoint M7", "^SAMSUNG HM([54]00J|320I|250H|161H|120G)I$"
		Data.s "Samsung SpinPoint M7E", "^SAMSUNG HM641JI$"
		Data.s "Samsung SpinPoint MC30", "^SAMSUNG HM031HC$"
		Data.s "Samsung SpinPoint MP2", "^SAMSUNG HM((08|12|10)[01]HJ)|((25|20|16)[01]JJ)$"
		Data.s "Samsung SpinPoint MP4", "^SAMSUNG HM((64|50)0J|(32|25)0H)J$"
		Data.s "Samsung SpinPoint MU-X", "^SAMSUNG HM(320J|251J|160H)X$"
		Data.s "Samsung SpinPoint N2B", "^SAMSUNG HS((08[02]|06[0T]|04[0T])HB)|030GB|122JB$"
		Data.s "Samsung SpinPoint N3A", "^SAMSUNG HS(0[68]|12)YHA$"
		Data.s "Samsung SpinPoint N3B", "^SAMSUNG HS12UHE$"
		Data.s "Samsung SpinPoint N3C", "^SAMSUNG HS(0[68]VH|1[26]VJ)F$"
		Data.s "Samsung EcoGreen F1 CE ", "^SAMSUNG HA(753L|642J|502J|322H|252H|103U)I$"
		Data.s "Samsung EcoGreen F1 DT", "^SAMSUNG HD(753L|642J|502J|322H|252H|103U)I$"
		Data.s "Samsung EcoGreen F2", "^SAMSUNG HD(502HI|10[23]SI|15[34]UI)$"
		Data.s "Samsung EcoGreen F3", "^SAMSUNG HD(754J|503H|203W|253G|105S|153W)I$"
		Data.s "Maxtor Fireball 541DX", "^MAXTOR 2B0(0[468]|1[05]|20)H1$"
		Data.s "Maxtor Fireball 3", "^MAXTOR 2F0[234]0[JL]0$"
		Data.s "Maxtor DiamondMax 1750 Ultra ATA", "^MAXTOR 8(1750[AD]2|2560[AD]3|3240[AD]4|3500[AD]4|4320[AD]5|5250[AD]6|6480[AD]8|7000[AD]8)$"
		Data.s "Maxtor DiamondMax 2160 Ultra ATA", "^MAXTOR 8(2160D2|3228D3|3240D3|4320D4|6480D6|8400D8|8455D8)$"
		Data.s "Maxtor DiamondMax 2880 Ultra ATA", "^MAXTOR 9(0256D2|0288D2|0432D3|0510D4|0576D4|0648D5|0720D5|084[05]D6|0864D6|1008D[78]|1152D8)$"
		Data.s "Maxtor DiamondMax 3400 Ultra ATA", "^MAXTOR 9(1(360|350|202)D8|1190D7|10[12]0D6|0840D5|06[48]0D4|0510D3|0340D2|1(350|202)E8|1010E6|0840E5|0640E4)$";256k
		Data.s "Maxtor DiamondMax D540X", "^MAXTOR 4(G(120J6|160J[68])|[DK](020H1|040H2|060H3|080H4)$";2
		Data.s "Maxtor DiamondMax Plus D740X", "^MAXTOR 6L0(20[JL]1|40[JL]2|60[JL]3|80[JL]4)$";2
		Data.s "Maxtor DiamondMax Plus 2500 Ultra ATA", "^MAXTOR 9(0500D4|0625D5|0750D6|0840D7|0875D7|0910D8|1000D8)$"
		Data.s "Maxtor DiamondMax Plus 5120 Ultra ATA 33", "^MAXTOR 9(0512D2|0680D3|0750D3|0913D4|1024D4|1360D6|1536D6|1792D7|2048D8)$"
		Data.s "Maxtor DiamondMax Plus 6800 Ultra ATA 66", "^MAXTOR 9(2732U8|2390U7|2049U6|1707U5|1366U4|1024U3|0845U3|0683U2)$"
		Data.s "Maxtor DiamondMax 6800 Ultra ATA 66", "^MAXTOR 9(2720U8|2040U6|1360U4|1020U3|0845U3|0650U2)$";2
		Data.s "Maxtor DiamondMax D540X-4D", "^MAXTOR 4D0(20H1|40H2|60H3|80H4)$"
		Data.s "Maxtor DiamondMax 4320 Ultra ATA", "^MAXTOR (91728D8|91512D7|91303D6|91080D5|90845D4|90645D3|90648D[34]|90432D2)$"
		Data.s "Maxtor DiamondMax 17 VL", "^MAXTOR 9(0431U1|0641U2|0871U2|1301U3|1741U4)$";512K
		Data.s "Maxtor DiamondMax 20 VL", "^MAXTOR (94091U8|93071U6|92561U5|92041U4|917[34]1U4|91531U3|913[06]1U3|91021U2|908[47]1U2|90651U2|90431U1)$";512K
		Data.s "Maxtor DiamondMax 30 VL", "^MAXTOR (33073U4|32049U3|31536U2|30768U1)$";512K
		Data.s "Maxtor DiamondMax 36", "^MAXTOR (93652U8|92739U6|91826U4|91369U3|90913U2|90845U2|90435U1)$"
		Data.s "Maxtor DiamondMax 40 ATA 66", "^MAXTOR 9(0684U2|1024U2|136[29]U3|1536U3|1826U4|2049U4|2562U5|2739U6|3073U6|3652U8|4098U8)$";2
		Data.s "Maxtor DiamondMax Plus 40 (Ultra ATA 66 and Ultra ATA 100)", "^MAXTOR (54098[UH]8|53073[UH]6|52732[UH]6|52049[UH]4|51536[UH]3|51369[UH]3|51024[UH]2)$";2
		Data.s "Maxtor DiamondMax 40 VL Ultra ATA 100", "^MAXTOR 3(1024H1|1535H2|2049H2|3073H3|4098H4)( B)?$"
		Data.s "Maxtor DiamondMax Plus 45 Ulta ATA 100", "^MAXTOR 5(4610H6|4098H6|3073H4|2049H3|1536H2|1369H2|1023H2)$";2
		Data.s "Maxtor DiamondMax 60 ATA 66", "^MAXTOR 9(1023U2|1536U2|2049U3|2305U3|3073U4|4610U6|6147U8)$"
		Data.s "Maxtor DiamondMax 60 ATA 100", "^MAXTOR 9(1023H2|1536H2|2049H3|2305H3|3073H4|4610H6|6147H8)$"
		Data.s "Maxtor DiamondMax Plus 60", "^MAXTOR 5T0(60H6|40H4|30H3|20H2|10H1)$"
		Data.s "Maxtor DiamondMax 80", "^MAXTOR (98196H8|96147H6)$"
		Data.s "Maxtor DiamondMax 8S", "^MAXTOR 6[EN]040T0$";2
		Data.s "Maxtor DiamondMax 536DX", "^MAXTOR 4W(100H6|080H6|060H4|040H3|030H2)$"
		Data.s "Maxtor DiamondMax Plus 8", "^MAXTOR 6(E0[234]|K04)0L0$"
		Data.s "Maxtor DiamondMax 10 (ATA/133 and SATA/150)", "^MAXTOR 6(B(30|25|20|16|12|08)0[MPRS]|L(080[MLP]|(100|120)[MP]|160[MP]|200[MPRS]|250[RS]|300[RS]))0$"
		Data.s "Maxtor DiamondMax 10 (SATA/300)", "^MAXTOR 6V(080E|160E|200E|250F|300F|320F)0$"
		Data.s "Maxtor DiamondMax Plus 9", "^MAXTOR 6Y((060|080|120|160)L0|(080|120|160|200|250)P0|(060|080|120|160|200|250)M0)$"
		Data.s "Maxtor DiamondMax 11", "^MAXTOR 6H[45]00[FR]0$"
		Data.s "Maxtor DiamondMax 16", "^MAXTOR 4(R0[468]0[JL]0|R1[26]0L0|A160J0|A250J0|A300J0|R120L4)$"
		Data.s "Maxtor DiamondMax 17", "^MAXTOR 6G(080[LE]|160[PE]|250[PE]|320[PE])0$"
		Data.s "Seagate Maxtor DiamondMax 20", "^MAXTOR STM3(402111|802110|160[28]12|200827|25062[34]|300622)A$"
		Data.s "Seagate Maxtor DiamondMax 21", "^MAXTOR STM3(((402|80[28]|160[28])15)|250310|((2008|250[68]|3006|320[68])20)|250824|500630)AS?$"
		Data.s "Seagate Maxtor DiamondMax 22", "^MAXTOR STM3(160813|320614|500[368]20|750[36]30|1000[36](34|40))AS$"
		Data.s "Seagate Maxtor DiamondMax 23", "^MAXTOR STM3(16031|25031|32041|50041|75052|100052)8AS$";8/16/32
		Data.s "Seagate Maxtor OneTouch 4", "^MAXTOR STM30(2503|5004|7504)OT[AB]3E1-RK$";8/16/32
		Data.s "Seagate Maxtor OneTouch 4 Mini", "^MAXTOR STM90(8|12|16)03OT[AB]3E1-RK$";8
		Data.s "Maxtor MaXLine Plus II", "^MAXTOR 7Y250[PM]0$"
		Data.s "Maxtor MaXLine II", "^MAXTOR [45]A(25|30|32)0[JN]0$"
		Data.s "Maxtor MaXLine III (ATA/133 and SATA 1)", "^MAXTOR 7L(25|30)0[SR]0$"
		Data.s "Maxtor MaXLine III (SATA 2)", "^MAXTOR 7V(25|30)0F0$"
		Data.s "Maxtor MaXLine Pro 500", "^MAXTOR 7H500F0$"
		Data.s "Hitachi DK14FA-20B", "^HITACHI_DK14FA-20B$"
		Data.s "Hitachi Travelstar DK23XX/DK23XXB", "^HITACHI_DK23..-..B?$"
		Data.s "Hitachi Endurastar J4K20/N4K20", "^(HITACHI_DK23FA-20J|HTA422020F9AT[JN]0)$"
		Data.s "IBM Deskstar 14GXP and 16GP", "^IBM-DTTA-3(7101|7129|7144|5032|5043|5064|5084|5101|5129|5168)0$"
		Data.s "IBM Deskstar 25GP and 22GXP", "^IBM-DJNA-3(5(101|152|203|250)|7(091|135|180|220))0$"
		Data.s "IBM Travelstar 4GT", "^IBM-DTCA-2(324|409)0$"
		Data.s "IBM Travelstar 25GS, 18GT, and 12GN", "^IBM-DARA-2(25|18|15|12|09|06)000$"
		Data.s "IBM Travelstar 48GH, 30GN, and 15GN", "^(IBM-|Hitachi )?IC25(T048ATDA05|N0(30|20|15|12|10|07|06|05)ATDA04)-.$"
		Data.s "IBM Travelstar 32GH, 30GT, and 20GN", "^IBM-DJSA-2(32|30|20|10|05)$"
		Data.s "IBM Travelstar 4GN", "^IBM-DKLA-2(216|324|432)0$"
		Data.s "IBM Deskstar 37GP and 34GXP", "^IBM-DPTA-3(5(375|300|225|150)|7(342|273|205|136))0$"
		Data.s "IBM/Hitachi Travelstar 60GH and 40GN", "^(IBM-|Hitachi )?IC25(T060ATC[SX]05|N0[4321]0ATC[SX]04)-.$"
		Data.s "IBM/Hitachi Travelstar 40GNX", "^(IBM-|Hitachi )?IC25N0[42]0ATC[SX]05-.$"
		Data.s "Hitachi Travelstar 80GN", "^(HITACHI )?IC25N0[23468]0ATMR04-.$"
		Data.s "Hitachi Travelstar 4K40", "^(HITACHI )?HTS4240[234]0M9AT00$"
		Data.s "Hitachi Travelstar 5K80", "^(HITACHI )?HTS5480[8642]0M9AT00$"
		Data.s "Hitachi Travelstar 5K100", "^(HITACHI )?HTS5410[1864]0G9(AT|SA)00$"
		Data.s "Hitachi Travelstar E5K100", "^(HITACHI )?HTE541040G9(AT|SA)00$"
		Data.s "Hitachi Travelstar 5K120", "^(HITACHI )?HTS5412(60|80|10|12)H9(AT|SA)00$"
		Data.s "Hitachi Travelstar 5K160", "^(HITACHI )?HTS5416([468]0|1[26])J9(AT|SA)00$"
		Data.s "Hitachi Travelstar 7K60", "^(HITACHI )?HTS726060M9AT00$"
		Data.s "Hitachi Travelstar E7K60", "^(HITACHI )?HTE7260[46]0M9AT00$"
		Data.s "Hitachi Travelstar 7K100", "^(HITACHI )?HTS7210[168]0G9(AT|SA)00$"
		Data.s "Hitachi Travelstar E7K100", "^(HITACHI )?HTE7210[168]0G9(AT|SA)00$"
		Data.s "Hitachi Travelstar 7K200", "^(HITACHI )?HTS7220(80|10|12|16|20)K9(A3|SA)00$"
		Data.s "IBM/Hitachi Deskstar 120GXP", "^(IBM-)?IC35L((020|040|060|080|120)AVVA|0[24]0AVVN)07-[01]$"
		Data.s "IBM/Hitachi Deskstar GXP-180", "^(IBM-)?IC35L(030|060|090|120|180)AVV207-[01]$"
		Data.s "IBM Travelstar 14GS", "^IBM-DCYA-214000$"
		Data.s "IBM Travelstar 4LP", "^IBM-DTNA-2(180|216)0$"
		Data.s "Hitachi Deskstar 7K80", "^(HITACHI )?HDS7280([48]0PLAT20|(40)?PLA320|80PLA380)$"
		Data.s "Hitachi Deskstar 7K160", "^(HITACHI )?HDS7216(80|16)PLA[3T]80$"
		Data.s "Hitachi Deskstar 7K250", "^(HITACHI )?HDS7225((40|80|12|16)VLAT20|(12|16|25)VLAT80|(80|12|16|25)VLSA80)$"
		Data.s "Hitachi Deskstar T7K250", "^(HITACHI )?HDT7225((25|20|16)DLA(T80|380))$"
		Data.s "Hitachi Deskstar 7K400", "^(HITACHI )?HDS724040KL(AT|SA)80$"
		Data.s "Hitachi Deskstar 7K500", "^(HITACHI )?HDS725050KLA(360|T80)$"
		Data.s "Hitachi Deskstar T7K500", "^(HITACHI )?HDT7250(25|32|40|50)VLA(360|380|T80)$"
		Data.s "Hitachi Deskstar 7K1000", "^(HITACHI )?HDS7210(75|10)KLA330$"
		Data.s "Hitachi Ultrastar A7K2000", "^(HITACHI )?HUA7220(20|10|50)CLA33(0|1)$"
		Data.s "Hitachi Ultrastar 15K600", "^(HITACHI )?HUS1560(30|45|60)VL(S|F)(4|6)0(0|1)$"
		Data.s "Hitachi Ultrastar 15K450", "^(HITACHI )?HUS1545(30|45)VL(S|F)(3|4)00$"
		Data.s "Hitachi Ultrastar C15K147", "^(HITACHI )?HUC1514(14|73)CSS60(0|1)$"
		Data.s "Hitachi Ultrastar C10K300", "^(HITACHI )?HUC1030(14|30)CSS600$"
		Data.s "Hitachi Ultrastar 7K1000", "^(HITACHI )?HUA7210(50|75|10)KLA330$"
		Data.s "Hitachi Ultrastar 7K1000.C", "^(HITACHI )?HDS7210(16|25|32|50|64|75|10|20)CLA3(3|6|8)(0|2)$"
		Data.s "Hitachi Ultrastar 7K2000", "^(HITACHI )?HDS722020ALA330$"
		Data.s "Hitachi CinemaStar 7K1000.C", "^(HITACHI )?HCS7210(16|25|32|50|75|10)CLA3(3|8)2$"
		Data.s "Hitachi CinemaStar 5K1000", "^(HITACHI )?HCS5C(10(16|25|32|50|75|10)CLA382|3225SLA380)$"
		Data.s "Hitachi CinemaStar C5K500", "^(HITACHI )?HCC5450(16|25|32|50)B9A300$"
		Data.s "Hitachi CinemaStar Z5K320", "^(HITACHI )?HCC5432(16|25|32)A7A380$"
		Data.s "Hitachi CinemaStar 7K500", "^(HITACHI )?HTE7250(16|25|32|50)A9A364$"
		Data.s "Hitachi CinemaStar 5K500.B", "^(HITACHI )?HTE5450(16|25|32|50)B9A300$"
		Data.s "Hitachi CinemaStar Z7K320", "^(HITACHI )?HTE7232(16|25|32)A7A364$"
		Data.s "Hitachi CinemaStar Z5K320", "^(HITACHI )?HTE5432(16|25|32)A7A384$"
		Data.s "Hitachi EnduraStar J4K100", "^(HITACHI )?HEJ4210(40|80|10)G9(AT|SA)00$"
		Data.s "Hitachi EnduraStar N4K100", "^(HITACHI )?HEN4210(40|80|10)G9(AT00|T00)$"
		Data.s "Toshiba 2.5'' HDD (30-60 GB)", "^TOSHIBA MK((6034|4032)GSX|(6034|4032)GAX|(6026|4026|4019|3019)GAXB?|(6025|6021|4025|4021|4018|3025|3021|3018)GAS|(4036|3029)GACE?|(4018|3017)GAP)$"
		Data.s "Toshiba 2.5'' HDD (80 GB And above)", "^TOSHIBA MK(80(25GAS|26GAX|32GAX|32GSX)|10(31GAS|32GAX)|12(33GAS|34G[As]X)|2035GSS)$"
		Data.s "Toshiba 1.8'' HDD", "^TOSHIBA MK[23468]00[4-9]GA[HL]$"
		Data.s "Toshiba MK6022GAX", "^TOSHIBA MK6022GAX$"
		Data.s "Toshiba MK6409MAV", "^TOSHIBA MK6409MAV$"
		Data.s "Toshiba MK3019GAXB SUN30G", "^TOS MK3019GAXB SUN30G$"
		Data.s "Toshiba MK2016GAP", "^TOSHIBA MK2016GAP$"
		Data.s "Toshiba MK2017GAP", "^TOSHIBA MK2017GAP$"
		Data.s "Toshiba MK2018GAP", "^TOSHIBA MK2018GAP$"
		Data.s "Toshiba MK2018GAS", "^TOSHIBA MK2018GAS$"
		Data.s "Toshiba MK2023GAS", "^TOSHIBA MK2023GAS$"
		Data.s "Seagate Atlas 15K", "^(MAXTOR )?8C(018|036|073)[JL]0$";8
		Data.s "Seagate Atlas 15K II", "^(MAXTOR )?8[EK](036|073|147)[JL]0$";8
		Data.s "Seagate Atlas 15K II SAS", "^(MAXTOR )?8K(036|073|147)S0$";16
		Data.s "Seagate Atlas 10K III", "^(MAXTOR )?KU(018[JL]2|036[JL]4|073[JL]8)$";8
		Data.s "Seagate Atlas 10K IV", "^(MAXTOR )?8B(036|073|146)[LJ]0$";8
		Data.s "Seagate Atlas 10K V", "^(MAXTOR )?8[DJ](073|147|300)[LJ]0$";8
		Data.s "Seagate Momentus", "^ST9(20|28|40|48)11A$"
		Data.s "Seagate Momentus Blade Server", "^ST94811AB$"
		Data.s "Seagate Momentus XT", "^ST9(500562|320562|250561)0AS$";32
		Data.s "Seagate Momentus Thin", "^ST9(16|25)03010AS$";8
		Data.s "Seagate Momentus 42", "^ST9(2014|3015|4019)A$";2
		Data.s "Seagate Momentus 42.2", "^ST9(30219|402113)A$";2
		Data.s "Seagate Momentus 42.2", "^ST9(60821|808210|100822)A$";8
		Data.s "Seagate Momentus 54", "^ST9[24][08]11A$";8
		Data.s "Seagate Momentus 4200.2", "^ST9(120824|10082[25]|8082(9|10)|608(12|21)|50214|402112|30218)A$";8
		Data.s "Seagate Momentus 4200 N-Lite", "^ST940110A$";2
		Data.s "Seagate Momentus 4200.2", "^ST9(50212|40211[23]|3021[89])A$";2
		Data.s "Seagate Momentus 4200.3", "^ST9(408116|960813|80811)A$";8
		Data.s "Seagate Momentus 5400 PSD", "^ST9(1[26]08220|808212)AS$";8
		Data.s "Seagate Momentus 5400 FDE", "^ST9((500327|250317)AS|(40811|60814|80821|100826|120826)A)$";8
		Data.s "Seagate Momentus 5400 FDE.2 SATA", "^ST9(80816|120827|160824)AS$";8
		Data.s "Seagate Momentus 5400 FDE.3", "^ST9(32032|1[26]031)[29]AS$";8
		Data.s "Seagate Momentus 5400 FDE.4", "^ST9(80314|(1[26]|25)0317|(32|50)0327)AS$";8
		Data.s "Seagate Momentus 5400.1", "^ST93012AM?$";2
		Data.s "Seagate Momentus 5400.2", "^ST9(808211|60822|408114|308110|120821|10082[34]|8823|6812|4813|3811)AS?$"
		Data.s "Seagate Momentus 5400.3", "^ST9(4081[45]|6081[35]|8081[15]|100828|120822|160821)A$";8
		Data.s "Seagate Momentus 5400.3 ED", "^ST9(4081[45]|6081[35]|8081[15]|100828|120822|160821)AB$"
		Data.s "Seagate Momentus 5400.4", "^ST9((25|20|16)0827|120817)AS$";8
		Data.s "Seagate Momentus 5400.5", "^ST9((8|16)0310|320320)ASG?$";8
		Data.s "Seagate Momentus 5400.6", "^ST9((50|32)0325|250315|160314|120315)ASG?$";8
		Data.s "Seagate Momentus 5400.7", "^ST9(160316|250310|32031[02]|50032[01]|64032[02])AS$"
		Data.s "Seagate Momentus 7200 FDE", "^ST9(500421|250411)AS$";16
		Data.s "Seagate Momentus 7200.1", "^ST9(10021|80825|6023|4015)AS?$";8
		Data.s "Seagate Momentus 7200.2", "^ST9(80813|100821|120823|160823|200420)ASG?$";8/ 16 o 200
		Data.s "Seagate Momentus 7200.3", "^ST9(((8|12|16)0411)|((20|25|32)0421))ASG?$";16
		Data.s "Seagate Momentus 7200.4", "^ST9(120410|160412|250410|320423|500420)ASG?$";16
		Data.s "Seagate UX", "^ST3(10014A(CE)?|20014A)$"
		Data.s "Seagate U7", "^ST3(30012|40012|60012|80022|120020)A$"
		Data.s "Seagate U6", "^ST3(8002|6002|4081|3061|2041)0A$"
		Data.s "Seagate U5", "^ST3(40823|30621|20413|15311|10211)A$"
		Data.s "Seagate U4", "^ST3(2112|4311|6421|8421)A$"
		Data.s "Seagate U8", "^ST3(8410|4313|17221|13021)A$"
		Data.s "Seagate U10", "^ST3(20423|15323|10212)A$"
		Data.s "Seagate Constellation SAS", "^ST950043[01]SS$";16
		Data.s "Seagate Constellation SATA", "^ST9(500530|160511)NS$";32
		Data.s "Seagate Constellation ES", "^ST3(5|10|20)00(4[124][45]SS|5[124]4NS)$"
		Data.s "Seagate Cheetah 15K.7", "^ST3(300[56]|450[78]|600[09])57(FC|SS)$"
		Data.s "Seagate Cheetah 15K.6", "^ST3(4508|3006|1463)56(FC|SS)$"
		Data.s "Seagate Cheetah 15K.5", "^ST3(3006|1468|734)55(LW|LC|FC|SS)$"
		Data.s "Seagate Cheetah 15K.4", "^ST3(1468|734|367)54(LW|LC|FC|SS)$";8
		Data.s "Seagate Cheetah 15K.3", "^ST3(734|367|184)53(LW|LC|FC)$";8
		Data.s "Seagate Cheetah 10K.7", "^ST3(3000|1467|732|368)07(LW|LC|FC)$";8
		Data.s "Seagate Cheetah 10K.6", "^ST3(1468|733|366)07(LW|LC|FC)$";8
		Data.s "Seagate Cheetah X15", "^ST3(184|92)51(LW|LC)$";8
		Data.s "Seagate Cheetah X15-36LP", "^ST3(367|184)[53]2(LW|LC|FC)$";8
		Data.s "Seagate Cheetah T10 SAS", "^ST3(733|1467|3005)55SS$";8
		Data.s "Seagate Cheetah NS", "^ST3(3009|4007)55(FC|SS)$";8
		Data.s "Seagate Cheetah 9", "^ST19101(N|W|WC|WD|DC)$";8
		Data.s "Seagate Cheetah 9LP", "^ST3(91|45)02L[WC]$";8
		Data.s "Seagate Cheetah 73LP", "^ST3(734|366)05(LC|LCV|LW|FC)$"
		Data.s "Seagate Cheetah 73", "^ST173404(LC|LCV|LWV|LW|FC|FCV)$"
		Data.s "Seagate Cheetah 36", "^ST136403(LC|LCV|LWV|LW|FC|FCV)$"
		Data.s "Seagate Cheetah 36LP", "^ST336704(LC|LCV|LWV|LW|FC|FCV)$"
		Data.s "Seagate Cheetah 36XL", "^ST3(184|92)05L[WC]$"
		Data.s "Seagate Cheetah 36ES", "^ST3(367|184)[04]6L[WC]$";4
		Data.s "Seagate Cheetah 18", "^ST118202L[WC]$"
		Data.s "Seagate Cheetah 18XL", "^ST3(92|184)04L[WC]$"
		Data.s "Seagate Cheetah 18LP", "^ST3(91|182)[03]3(LW|LC|FC|LWV|LCV|FCV)$"
		Data.s "Seagate Cheetah 4LP", "^ST34501(N|W|WC|WD|DC)$"
		Data.s "Seagate DB35.4", "^ST3250310CS$"
		Data.s "Seagate DB35.3", "^ST3(8|16|25|32|40|50|75)0(640|8[234]0|215)[SA]CE$"
		Data.s "Seagate DB32 7200.2", "^ST3(8|12|16|20|25|30|40|50)0(8(41|33|2[247])|2110|21[23])[SA]CE$"
		Data.s "Seagate DB35 (IDE)", "^ST3(20|25|30|40)08(2[36]|3[12])ACE$"
		Data.s "Seagate DB35 (SATA)", "^ST3(20|25|30|40)08(2[36]|3[12])SCE$"
		Data.s "Seagate EE25.2", "^ST9[48]081[78][SA]M$"
		Data.s "Seagate EE25.1", "^ST9[234]081[34]AM$"
		Data.s "Seagate Pipeline HD.2 SATA", "^ST3(16|25|32|50|100)0(3(1[126]|22)|4(1([234]|24)CS$"
		Data.s "Seagate Pipeline HD Pro", "^ST31000533CS$"
		Data.s "Seagate Pipeline HD Mini SATA", "^ST9(16|25|32|50)03[12](1|3|8|10)CS$"
		Data.s "Seagate Pipeline HD", "^ST3(16|25|32|50|100)03[12][0126]CS$";8
		Data.s "Seagate Savvio 15K.2", "^ST9((146[78]52)|73[34]52)SS$"
		Data.s "Seagate Savvio 15K.1 FC", "^ST9(367|734)51FC$"
		Data.s "Seagate Savvio 15K", "^ST9(367|734)51SS$";16
		Data.s "Seagate Savvio 10K.4", "^ST9(600[12]|450[34])04(SS|FC)$"
		Data.s "Seagate Savvio 10K.3", "^ST9(300[65]|146[78])03SS$";16
		Data.s "Seagate Savvio 10K.2", "^ST9(1468|734)02SS$";16
		Data.s "Seagate Savvio 10K", "^ST9(734|367)01(LC|SS)$";8
		Data.s "Seagate SV35.5", "^ST3(1000525|500410|250311)SV$";32/16/8
		Data.s "Seagate SV35.4", "^ST3320410SV$";16
		Data.s "Seagate SV35.3", "^ST3(100034|75033|50032|25031)0SV$";16
		Data.s "Seagate SV35.2", "^ST3(750640|500630|320620|250820|160815)[AS]V$"
		Data.s "Seagate SV35", "^ST3(500641|250824|160812)[AS]V$";16/8/8
		Data.s "Seagate Barracuda ATA", "^ST3(2804|2043|1362|1022|6810)0A$"
		Data.s "Seagate Barracuda ATA II", "^ST3(3063|2042|1532|1021)0A$"
		Data.s "Seagate Barracuda ATA II 100", "^ST3(30631|20424|15324|10216)A$"
		Data.s "Seagate Barracuda ATA III", "^ST3(40824|30620|20414|15310|10215)A$"
		Data.s "Seagate Barracuda ATA IV", "^ST3(20011|30011|40016|60021|80021)A$"
		Data.s "Seagate Barracuda ATA V", "^ST3(12002(3A|4A|9A|3AS)|800(23A|15A|23AS)|60(015A|210A)|40017A)$"
		Data.s "Seagate Barracuda 5400.1", "^ST340015A$"
		Data.s "Seagate Barracuda 7200.7 and 7200.7 Plus", "^ST3(200021A|200822AS?|16002[13]AS?|12002[26]AS?|1[26]082[78]AS|8001[13]AS?|80817AS|60014A|40111AS|40014AS?)$"
		Data.s "Seagate Barracuda 7200.8", "^ST3(400[68]32|300[68]31|250[68]23|200826)AS?$"
		Data.s "Seagate Barracuda 7200.9", "^ST3(402111?|80[28]110?|120[28]1[0134]|160[28]1[012]|200827|250[68]24|300[68]22|(320|400)[68]33|500[68](32|41))AS?$"
		Data.s "Seagate Barracuda 7200.10", "^ST3((80|160)[28]15|200820|250[34]10|(250|300|320|400)[68]20|500[68]30|750[68]40)AS?$";16
		Data.s "Seagate Barracuda 7200.11", "^ST3(500[368]2|750[36]3|1000[36]4)0AS$";OK
		Data.s "Seagate Barracuda 7200.11", "^ST3(1500341|1000333|640[36]23|320[68]13|160813)AS$";firmware with bugs!
		Data.s "Seagate Barracuda 7200.12", "^ST3(160318|250318|320418|50041[08]|750528|1000528)AS$";8/16/32
		Data.s "Seagate Barracuda LP", "^ST3(10|15|20)005(20|41|42)|(500412)AS?$"
		Data.s "Seagate Barracuda 9LP", "^ST3(91|45)73(N|W|WD|LW|WC|LC)$"
		Data.s "Seagate Barracuda 9", "^ST19171(N|W|WD|WC|DC)$"
		Data.s "Seagate Barracuda 4", "^ST15150(N|W|ND|WD|WC|DC)$"
		Data.s "Seagate Barracuda 4XL", "^ST3(22|45)72(N|W|WD|WC|DC)$"
		Data.s "Seagate Barracuda 4LP", "^ST3(22|45|21|43)71(N|W|WD|WC|DC)$"
		Data.s "Seagate Barracuda 2LP", "^ST3(12|25)50(N|ND|W|WD|WC|DC)$"
		Data.s "Seagate Barracuda 2 / 2HP", "^ST12450(W|WD)$"
		Data.s "Seagate Barracuda 18", "^ST118273(N|W|WD|LW|WC|LC)$"
		Data.s "Seagate Barracuda 1", "^ST11950(N|ND|W|WD)$"
		Data.s "Seagate Barracuda 2", "^ST12550(N|ND|W|WD)$"
		Data.s "Seagate Barracuda 18LP", "^ST3(91|182)75L[WC]$"
		Data.s "Seagate Barracuda 18XL", "^ST3(92|184)[123]6(N|W|LW|LC|LCV|LWV)$"
		Data.s "Seagate Barracuda 50", "^ST150176L[WC]$"
		Data.s "Seagate Barracuda ES", "^ST3(250[68]2|320[68]2|400[68]2|500[68]3|750[68]4)0NS$"
		Data.s "Seagate Barracuda ES+", "^ST3(25|32|40|50|75)0[68][234]1NS$"
		Data.s "Seagate Barracuda ES.2", "^ST3((500620|750630|1000640)S)|((250310|250610|500320|750330|1000340)N)S$"
		Data.s "Seagate Barracuda 36", "^ST136475L[WC]$"
		Data.s "Seagate Barracuda 36ES", "^ST3(3673|184[13])7(N|W|LW|LC)$"
		Data.s "Seagate Barracuda 36ES2", "^ST3(369|184)(18N|38LW)$";64
		Data.s "Seagate Barracuda 180", "^ST1181677(LC|LW|FC)V$";64
		Data.s "Seagate Barracuda XT", "^ST32000641AS$";64
		Data.s "Seagate Medalist 17240", "^ST317240A$"
		Data.s "Seagate Medalist 13030", "^ST313030A$"
		Data.s "Seagate Medalist 10231", "^ST310231A$"
		Data.s "Seagate Medalist 8420", "^ST38420A$"
		Data.s "Seagate Medalist 4310", "^ST34310A$"
		Data.s "Seagate Medalist 17242", "^ST317242A$"
		Data.s "Seagate Medalist 13032", "^ST313032A$"
		Data.s "Seagate Medalist 10232", "^ST310232A$"
		Data.s "Seagate Medalist 8422", "^ST38422A$"
		Data.s "Seagate Medalist 4312", "^ST34312A$"
		Data.s "Seagate Medalist 2110", "^ST32110A$"
		Data.s "Seagate Medalist 3221", "^ST33221A$"
		Data.s "Seagate Medalist 4321", "^ST34321A$"
		Data.s "Seagate Medalist 6531", "^ST36531A$"
		Data.s "Seagate Medalist 8641", "^ST38641A$"
		Data.s "Seagate NL35", "^ST3(250623|250823|400632|400832|250824|250624|400633|400833|500641|500841)NS$"
		Data.s "Seagate DB35.3", "^ST3((8|16)0215|(25|32|40)0820|500830|750[68]40)[AS]CE$"
		Data.s "Western Digital Protege", "^WDC WD([2468]00E|1[26]00A)B-.*$"
		Data.s "Western Digital Caviar", "^WDC WD(2|3|4|6|8|10|12|16|18|20|25)00BB-.*$"
		Data.s "Western Digital Caviar Black", "^WDC WD((((50|64|75)01A)|1001F)ALS)|2001FASS|1002FAEX$"
		Data.s "Western Digital Caviar Green", "^WDC WD((50|64|75)00AAC|(64|80)00AAR|(10|15|20)EAR|(50|64|75)00AAD|(10|15|20)EAD|(50|64|75)00AAV|10EAV)S$"
		Data.s "Western Digital Caviar Blue SATA with 32MB cache", "^WDC WD10EALS$"
		Data.s "Western Digital Caviar Blue SATA with 16MB cache", "^WDC WD(25|32|40|50|64|75)00AAKS$"
		Data.s "Western Digital Caviar Blue SATA with 8MB cache", "^WDC WD(8|12|16|25|32|40|50)00AAJS$"
		Data.s "Western Digital Caviar Blue SATA with 8MB cache", "^WDC WD(400JB|800JD)"
		Data.s "Western Digital Caviar Blue SATA with 2MB cache", "^WDC WD(800BD|1600AABS)$"
		Data.s "Western Digital Caviar Blue EIDE with 16MB cache", "^WDC WD(32|40|50)00AAKB$"
		Data.s "Western Digital Caviar Blue EIDE with 8MB cache", "^WDC WD(8|16|25|32|40|50)00AAJB$"
		Data.s "Western Digital Caviar Blue EIDE with 8MB cache", "^WDC WD800JB$"
		Data.s "Western Digital Caviar Blue EIDE with 2MB cache", "^WDC WD1600AABB$"
		Data.s "Western Digital Caviar Blue EIDE with 2MB cache", "^WDC WD([48]00BB)$"
		Data.s "Western Digital AV", "^WDC WD(16|25|32|50)00AVJ[BS]$";8
		Data.s "Western Digital AV", "^WDC WD1600AVBS$";2
		Data.s "Western Digital AV-GP", "^WDC WD((16|25|32|50|64|75)00A|10E)VV|(50|75)00AVD|((10|15|20)EVD)|(10EUR)S$";8/32
		Data.s "Western Digital AV-25", "^WDC WD(16|25|32|50)BUDT$";32
		Data.s "Western Digital Caviar AC12500", "^WDC AC12500.?"
		Data.s "Western Digital Caviar AC14300", "^WDC AC14300.?"
		Data.s "Western Digital Caviar AC23200", "^WDC AC23200.?"
		Data.s "Western Digital Caviar AC24300", "^WDC AC24300.?"
		Data.s "Western Digital Caviar AC25100", "^WDC AC25100.?"
		Data.s "Western Digital Caviar AC36400", "^WDC AC36400.?"
		Data.s "Western Digital Caviar AC38400", "^WDC AC38400.?"
		Data.s "Western Digital Caviar WDxxxAB", "^WDC WD(3|4|6)00AB-.*$"
		Data.s "Western Digital Caviar WDxxxAA", "^WDC WD...?AA(-.*)?$"
		Data.s "Western Digital Caviar WDxxxBA", "^WDC WD...BA$"
		Data.s "Western Digital Caviar Serial ATA", "^WDC WD(4|8|20|32)00BD-.*$"
		Data.s "Western Digital Caviar SE", "^WDC WD((4|6|8|10|12|16|18|20|25|30|32|40|50)00(JB|PB|AAJB|AAKB))-.*$"
		Data.s "Western Digital Caviar SE Serial ATA", "^WDC WD((4|8|12|16|20|25|32|40)00(JD|KD))-.*$"
		Data.s "Western Digital Caviar Second Generation Serial ATA", "^WDC WD((8|12|16|20|25|30|32|40|50|75)00(JS|KS|AABS|AAJS|AAKS))-.*$"
		Data.s "Western Digital Caviar RE Serial ATA", "^WDC WD((12|16|25|32|40|50|75)00(SD|YD|YR|YS|ABYS|AYYS))-.*$"
		Data.s "Western Digital Caviar RE EIDE", "^WDC WD((12|16|25|32)00SB)-.*$"
		Data.s "Western Digital RE2-GP", "^WDC WD(7500A|1000F)YPS$";16
		Data.s "Western Digital RE3", "^WDC WD((25|32|50|75)02A|1002F)BYS$";16/32
		Data.s "Western Digital RE4", "^WDC WD(25|50|10|15|20)03([AF]BYX|FYYS)$";64
		Data.s "Western Digital RE4-GP", "^WDC WD2002FYPS$";64
		Data.s "Western Digital Raptor", "^WDC WD((360|740|800)GD|(360|740|1500)ADFD)-.*$"
		Data.s "Western Digital VelociRaptor", "^WDC WD(15|30|45|60)00[BH]L(FS|HX)$";16
		Data.s "Western Digital Scorpio", "^WDC WD((4|6|8|10|12|16|20|25)00(UE|VE|BEAS|BEVE|BEVS))-.*$"
		Data.s "Western Digital Scorpio Black", "^WDC WD(8|12|16|25|32|50)00B[EJ]KT$";16
		Data.s "Western Digital Scorpio Blue", "^WDC WD(8|12|16|25|32|40|50|64|75)00B(EV[TSE]|PVT)$";8
		Data.s "Western Digital SiliconEdge", "^WDC SSC-D0(064|128|256)SC-2100$"
		Data.s "Quantum BIGFOOT TS10.0A", "^QUANTUM BIGFOOT TS10.0A$"
		Data.s "Quantum FIREBALLlct15 20 And QUANTUM FIREBALLlct15 30", "^QUANTUM FIREBALLlct15 [123]0$"
		Data.s "Quantum FIREBALLlct20", "^QUANTUM FIREBALLlct20 [234]0$"
		Data.s "Quantum FIREBALL CX10.2A", "^QUANTUM FIREBALL CX10.2A$"
		Data.s "Quantum Fireball Plus LM", "^QUANTUM FIREBALLP LM(10.2|15|20.5|30)$"
		Data.s "Quantum Fireball CR", "^QUANTUM FIREBALL CR(4.3|8.4)A$"
		Data.s "Quantum FIREBALLP AS10.2, AS20.5, AS30.0, And AS40.0", "^QUANTUM FIREBALLP AS(10.2|20.5|30.0|40.0)$"
		Data.s "Quantum FIREBALL EX6.4A", "^QUANTUM FIREBALL EX6.4A$"
		Data.s "Quantum FIREBALL ST3.2A", "^QUANTUM FIREBALL ST(3.2|4.3)A$"
		Data.s "Quantum FIREBALL EX3.2A", "^QUANTUM FIREBALL EX3.2A$"
		Data.s "Quantum FIREBALLP KX27.3", "^QUANTUM FIREBALLP KX27.3$"
		Data.s "Quantum Fireball Plus KA", "^QUANTUM FIREBALLP KA(9|10).1$"
		Data.s "Quantum Fireball SE", "^QUANTUM FIREBALL SE4.3A$"
		Data.s ""	; Marks end of data
EndDataSection
; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 396
; FirstLine = 336
; Folding = -
; EnableXP
; EnableAdmin
; EnableOnError
; CurrentDirectory = F:\120GB\WInfo.exe\
; CompileSourceDirectory